import numpy as np

from context import offfile
from context import sphere

epsilon = 0.0001

def test_through():
    # open test file
    vertices = np.genfromtxt("tests/data/eight_min.csv", delimiter=" ")

    # check through sphere
    centre, radius = sphere.through(vertices, np.array([510]))
    assert centre[0] == -0.00002
    assert centre[1] == 0.00000
    assert centre[2] == 1.28100
    assert radius == 0

    # check through sphere
    centre, radius = sphere.through(vertices, np.array([318]))
    assert centre[0] == 0.00002
    assert centre[1] == 0.00000
    assert centre[2] == -1.28100
    assert radius == 0

    # check through sphere
    centre, radius = sphere.through(vertices, np.array([318, 510]))
    assert np.abs(radius - 1.2810) < epsilon

    # check through sphere
    centre, radius = sphere.through(vertices, np.array([510, 318]))
    assert np.abs(radius - 1.2810) < epsilon

    # check through sphere
    centre, radius = sphere.through(vertices, np.array([510, 318, 512]))
    assert np.abs(centre[0] - 0.080248) < epsilon
    assert np.abs(centre[1] - 0.00001739) < epsilon
    assert np.abs(centre[2] - 0.0000011464) < epsilon
    assert np.abs(radius - 1.2835) < epsilon

    # check through sphere
    centre, radius = sphere.through(vertices,
        np.array([510, 318, 512, 316]))
    assert np.isnan(centre[0])
    assert np.isnan(centre[1])
    assert np.isnan(centre[2])
    assert radius == np.inf

def test_minsphere():
    # open test file
    vertices = np.genfromtxt("tests/data/eight_min.csv", delimiter=" ")

    # check minsphere
    centre, radius, basis = sphere.minsphere(vertices, np.array([]),
        np.array([510]), np.array([]), 2)
    assert centre[0] == -0.00002
    assert centre[1] == 0.00000
    assert centre[2] == 1.28100
    assert radius == 0
    assert basis[0] == 510

    # check minisphere
    centre, radius, basis = sphere.minsphere(vertices, np.array([]),
        np.array([510]), np.array([318]), 2)
