import numpy as np
import pandas as pd

def read_off_panda_filename(file_name):
    f = open(file_name, 'r')
    return read_off_panda(f)

def read_off_panda(f):
    """ Read .OFF file

    Args:
        file_path: path to the file containing the files
    Returns:
        matrix containing values in file

    """
    # read the header
    header = pd.read_csv(f, delimiter=" ", header=None, skiprows=1,
        nrows=1).values
    vertex_count = header[0][0]

    # move back to the beginning of the file
    f.seek(0)

    # read the vertices from the file
    vertices = pd.read_csv(f, delimiter=" ", header=None, skiprows=2,
        nrows=766).values

    return vertices

def read_off(file_path):
    """ Read .OFF file

    Args:
        file_path: path to the file containing the files
    Returns:
        matrix containing values in file

    """
    # read the header
    header = np.genfromtxt(file_path, delimiter=" ", skip_header=1, max_rows=1)
    vertex_count = header[0]

    # read the vertices from the file
    vertices = np.genfromtxt(file_path, delimiter=" ", skip_header=2,
        max_rows=vertex_count)

    return vertices
